## clazy 1.17

=== debian/changelog ===
clazy (1.17-2) unstable; urgency=medium

  * Clean also the generated '.fixed', and '.yaml' files of the test suite run.
    (Closes: #1044015 for real; if not, please open a new bug)
  * Run the tests at build time using the upstream build system:
    - use dh_auto_test, removing all the bits that are handled automatically
    - pass tests to exclude to ctest via -E, with a bit of quoting required
    - clarify that the excluded qt6-* tests are now needed only for the
      'run-tests' autopkgtest

 -- Pino Toscano <pino@debian.org>  Sun, 22 Feb 2026 07:48:15 +0100

clazy (1.17-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - debian-tests-extra-libs.diff: drop, as the code for it was removed, and
      hopefully the is no more need to inject custom linker flags for tests
    - select-clangpp.diff: refresh
    - tests-clang-tidy-envvar.diff: drop, as upstream provides something now
  * Stop excluding the qt6-header-fixes on certain architectures, as this test
    was removed.
  * Adapt the 'run-tests' autopkgtest to set the CLANGTIDY environment variable
    instead of the previous home-grown CLAZY_CLANG_TIDY for the clang-tidy
    executable.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Disable/empty the list of architectures that need -latomic for now, as the
    only architecture there (armel) was discontinued.
  * Clean also the generated '.pch; files of the test suite run.
    (Closes: #1044015)
  * Exclude the qt6-* tests, as the test cases for them were left after the
    removal of those checks.

 -- Pino Toscano <pino@debian.org>  Thu, 19 Feb 2026 09:02:47 +0100
